(function(_window, _logLevel, _utils) {
    'use strict';

    var DEFAULT_LEVEL = 5,
        log = {
            ALL: 0,
            MAX_LOGS: 1,
            VERBOSE: 2,
            DEBUG: 3,
            INFO: 4,
            WARN: 5,
            ERROR: 6,
            ASSERT: 7,
            logLevel: _utils.isInteger(_logLevel) ? _logLevel : DEFAULT_LEVEL,

            v: function() {
                if (this.logLevel <= this.VERBOSE) {
                    console.log.apply(console, arguments);
                }
            },
            d: function() {
                if (this.logLevel <= this.DEBUG) {
                    console.log.apply(console, arguments);
                }
            },
            i: function() {
                if (this.logLevel <= this.INFO) {
                    console.log.apply(console, arguments);
                }
            },
            w: function() {
                if (this.logLevel <= this.WARN) {
                    console.log.apply(console, arguments);
                }
            },
            e: function() {
                if (this.logLevel <= this.ERROR) {
                    console.log.apply(console, arguments);
                }
            },
            shouldLog: function(level) {
                return this.logLevel <= level;
            }
        };

    _window.log = log;
})(window, window.logLevel, window.utils);
